<?php
/**
 * @package    HikaMarket for Joomla!
 * @version    1.0.0
 * @author     Ashdown Software
 * @copyright  (C) 2016 Ashdown Software. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashopHolidayMessage extends JPlugin {

	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	public function onBeforeVendorUpdate(&$vendor, &$do) {

		$vendor_holiday_enable_old = $vendor->old->vendor_holiday_enable;
		$vendor_holiday_enable_new = $vendor->vendor_holiday_enable;
		
		$pluginsClass = hikashop_get('class.plugins');
		$plugin = $pluginsClass->getByName('hikashop','holidaymessage');
			
		if(empty($plugin->params['send_email'])){
			$plugin->params['send_email'] = '';
		}
		$send_email = $plugin->params['send_email'];
			
		if(empty($plugin->params['email'])){
			$plugin->params['email'] = '';
		}
		$email = $plugin->params['email'];
		
		// if the holiday status has changed notify the main vendor
		if ($vendor_holiday_enable_old <> $vendor_holiday_enable_new and $send_email) {
			$mailer = JFactory::getMailer();
			
			$config = JFactory::getConfig();
			$sender = array( 
			    $config->get( 'mailfrom' ),
			    $config->get( 'fromname' ) 
			);
			$mailer->setSender($sender);
			
			$mailer->addRecipient($email);
			
			if($vendor->vendor_holiday_enable === 'yes') {
				$status = "Enabled";
			} else {
				$status = "Disabled";
			} 
			
			$mailer->setSubject('A vendor has changed  their holiday status');
			
			$date = new DateTime($vendor->vendor_holiday_start);
			$start = $date->format('j M Y');
			$date = new DateTime($vendor->vendor_holiday_end);
			$end = $date->format('j M Y');
			
			$body = "Vendor: ".$vendor->vendor_name."\n";
			$body .= "Company: ".$vendor->vendor_address_company."\n";
			$body .= "Holiday message status has been changed to: ".$status ."\n";
			$body .= "Holiday message start date: ".$start."\n";
			$body .= "Holiday message end date: ".$end."\n";
			$body .= "Holiday message: ".$vendor->vendor_holiday_message."\n";
			$mailer->setBody($body);
			
			$send = $mailer->Send();
		}
		
	}

	public function onHikashopBeforeDisplayView(&$view){
		
		$viewName = $view->getName();
		$layout = $view->getLayout();
		if($viewName!='product' || $layout!='show') return;
		
		$productClass = hikashop_get('class.product');
		$product_id = $view->element->product_id;
		$product=$productClass->get($product_id);
		$product_type = $product->product_type;
		$product_parent_id=$product->product_parent_id;

		$db = JFactory::getDBO();
		
		if ($product_type == 'variant') {
			//grab the vendor id from the parent
			$db->setQuery('Select * From #__hikashop_product where product_id = '.$product_parent_id); 
		} else {
			$db->setQuery('Select * From #__hikashop_product where product_id = '.$product_id); 
		}
		$product = $db->loadObject();
		$vendor_id = $product->product_vendor_id;
		
		// grab the vendor holiday details		
		$db->setQuery('Select * From #__hikamarket_vendor where vendor_id = '.$vendor_id); 
		$vendor = $db->loadObject();
		if ($vendor !=null) {
			$holiday_start = $vendor->vendor_holiday_start;
			$holiday_end = $vendor->vendor_holiday_end;
			$holiday_message = $vendor->vendor_holiday_message;
			$holiday_show_message = $vendor->vendor_holiday_enable;
			

			if (date("YmdHis") >= $holiday_start and date("YmdHis") <= $holiday_end and $holiday_show_message == 'yes') {
					$view->element->extraData->rightMiddle []='<p style="color:#ff0000;" id="ts_holidaymessage">'.$holiday_message.'</p>';
			}
		}
	}

}
